/*
* Copyright © 2010 Martin Gräßlin <kde@martin-graesslin.com>
* Copyright © 2008 Dennis Kasprzyk <onestone@opencompositing.org>
* Copyright © 2006 Novell, Inc.
* Copyright © 2006 Volker Krause <vkrause@kde.org>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
* MA 02110-1301, USA.
*
* Author: David Reveman <davidr@novell.com>
*/
#ifndef AURORAE_AURORAEDECORATION_H
#define AURORAE_AURORAEDECORATION_H
#include <KApplication>
#include <netwm.h>

#define ROOT_OFF_X 8192
#define ROOT_OFF_Y 8192

namespace Aurorae
{

class Client;
class AuroraeTheme;

class AuroraeDecoration : public KApplication
{
    Q_OBJECT
public:
    AuroraeDecoration();
    ~AuroraeDecoration();

    bool enableDecorations();

    static NETRootInfo *rootInfo (void) {
        return m_rootInfo;
    }

private Q_SLOTS:
    void handleWindowAdded(WId id);
    void handleWindowRemoved(WId id);
    void handleActiveWindowChanged(WId id);
    void handleWindowChanged(WId id, const unsigned long *properties);

private:
    static NETRootInfo *m_rootInfo;
    AuroraeTheme *m_theme;
    QMap<WId, Client*> m_clients;
    QMap<WId, Client*> m_frames;
    WId m_activeId;
    WId m_compositeWindow;
};
}

#endif // AURORAE_AURORAE_H
